Lua_TuJianTheUpgradePlane  = class("Lua_TuJianTheUpgradePlane", Lua_DisplayObject);
function Lua_TuJianTheUpgradePlane:ctor(p, class_id, career)
	self.class_id = class_id;
	self.career = career;
	self:superCall("ctor", p, "TuJianTheUpgradePlan_skin");
end

function Lua_TuJianTheUpgradePlane:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 980, 440));
	self.dragList:setListCell(Lua_TuJianTheUpgradeItem, 430, 980, 1000);
	self.dragList:setCellScaleChange(true, 1, 1, 340, self, self.onCallBack);
	self.dragList:setLocation(132, 52, 0);

	local arr = DataCenter.TuJianUtil:getArrByClassIdAndCareer(self.class_id, self.career);
	self.pageLen = math.ceil(arr:getSize() / 3);

	local posX;
	local icon;
	local perWidth = 40;
	self.TuJianTipList = Array();
	for i = 1, self.pageLen do
		posX = -perWidth * self.pageLen / 2 + perWidth * (i - 1) + perWidth / 2 + 130;
		icon = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_widget_2y", posX, -185, 0, 0);
		icon.name = tostring(i);
		icon:setDepth(5);
		icon:addClickFuntion(self, self.onPageClick);
		self.TuJianTipList:add(icon);
	end

	self.wenhao:addClickFuntion(self, self.onHelp); -- 问号

	self:showTheUpgradeInfo();
	self:addLuaEvent("SHOW_ILLUSINFO", self, self.showTheUpgradeInfo); -- 返回面板信息
end

function Lua_TuJianTheUpgradePlane:showTheUpgradeInfo()
	local illusArr = DataCenter.TuJianUtil:getArrByClassIdAndCareer(self.class_id, self.career);
	local len = illusArr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not DataCenter.TujianData:noLvSortFun(illusArr[i], illusArr[j]) then -- 排序
				local temp = illusArr[i];
				illusArr[i] = illusArr[j];
				illusArr[j] = temp;
			end
		end
	end

	local arr = Array();
	for i = 1, self.pageLen do
		arr:add({page = i, startIndex = (i - 1) * 3, arr = illusArr});
	end
	self.dragList:setLuaArrayData(arr, true);

	self:theUpgradeItem();
end

function Lua_TuJianTheUpgradePlane:theUpgradeItem()
	self:returnShowItem();

	local property = {[2001] = 120322, [2008] = 120323, [2009] = 120324,
		[2003] = 120325, [2004] = 120326, [2005] = 120327, [2006] = 120328};

	local classNum = DataCenter.TujianData:getClassList(self.class_id); -- 激活数量
	local calssCfg = getConfig({"tujian_calss", self.class_id});
	local illusName = calssCfg.illus_class_name; -- 图鉴名
	local info = DataCenter.TuJianUtil:getArrByClassIdAndActiveNum(self.class_id,classNum);
	if info ~= nil then
		local item;
		if info.curInfo ~= nil then
			if info.nextInfo ~= nil then
				self.property_Label.text = LanUtil.formateStr(LanUtil.getValue(120304), tostring(info.curInfo.active), tostring(illusName));
				self.property_Label1.text = LanUtil.formateStr(LanUtil.getValue(120304), tostring(info.nextInfo.active), tostring(illusName));

				local curLen = #info.curInfo.attr_type_list;
				for i = 1, curLen do
					item = self:createShowItem();
					item:setAttrTxt(22, 22, "[00E125]"..LanUtil.getValue(property[info.curInfo.attr_type_list[i]]).."[-]", "[00E125]+"..info.curInfo.value_list[i], 0);
					item:setLocation(-95, -260 - (i - 1) * 25, 0);
				end
				
				local nextLen = #info.nextInfo.attr_type_list;
				for i = 1, nextLen do
					item = self:createShowItem();
					item:setAttrTxt(22, 22, "[85A8BE]"..LanUtil.getValue(property[info.nextInfo.attr_type_list[i]]).."[-]", "[85A8BE]+"..info.nextInfo.value_list[i], 0);
					item:setLocation(260, -260 - (i - 1) * 25, 0);
				end
			else
				self.property_Label.text = LanUtil.formateStr(LanUtil.getValue(120304), tostring(info.curInfo.active), tostring(illusName));
				self.property_Label1:setEnable(false);
				self.arrows:setEnable(false);

				local curLen = #info.curInfo.attr_type_list;
				for i = 1, curLen do
					item = self:createShowItem();
					item:setAttrTxt(22, 22, "[00E125]"..LanUtil.getValue(property[info.curInfo.attr_type_list[i]]).."[-]", "[00E125]+"..info.curInfo.value_list[i], 0);
					item:setLocation(0, -260 - (i - 1) * 25, 0);
				end
			end
		else
			if info.nextInfo ~= nil then
				self.property_Label.text = LanUtil.formateStr(LanUtil.getValue(120304), tostring(0), tostring(illusName));
				self.property_Label1.text = LanUtil.formateStr(LanUtil.getValue(120304), tostring(info.nextInfo.active), tostring(illusName));

				local nextLen = #info.nextInfo.attr_type_list;
				for i = 1, nextLen do
					item = self:createShowItem();
					item:setAttrTxt(22, 22, "[00E125]"..LanUtil.getValue(property[info.nextInfo.attr_type_list[i]]).."[-]", "[00E125]+"..0, 0);
					item:setLocation(-95, -260 - (i - 1) * 25, 0);
				end

				for i = 1, nextLen do
					item = self:createShowItem();
					item:setAttrTxt(22, 22, "[85A8BE]"..LanUtil.getValue(property[info.nextInfo.attr_type_list[i]]).."[-]", "[85A8BE]+"..info.nextInfo.value_list[i], 0);
					item:setLocation(260, -260 - (i - 1) * 25, 0);
				end
			end
		end
	end
end

function Lua_TuJianTheUpgradePlane:returnShowItem()
	if self._itemShowArr ~= nil then
		local item;
		for i = 1, self._itemShowArr:getSize() do
			item = self._itemShowArr:shift();
			item:setEnable(false);
			self._itemHideArr:add(item);
		end
	end
end

function Lua_TuJianTheUpgradePlane:createShowItem()
	if self._itemShowArr == nil then
		self._itemShowArr = Array();
		self._itemHideArr = Array();
	end

	local item;
	if self._itemHideArr:getSize() > 0 then
		item = self._itemHideArr:shift();
		item:setEnable(true);
	else
		item = Lua_ShowItem.new(self.content);
	end
	self._itemShowArr:add(item);
	return item;
end

function Lua_TuJianTheUpgradePlane:onCallBack(index)
	for i = 1, self.TuJianTipList:getSize() do
		if i == index then
			self.TuJianTipList[i]:setAltas("common_atlas_2", "ui_common_widget_1y");
		else
			self.TuJianTipList[i]:setAltas("common_atlas_2", "ui_common_widget_2y");
		end
	end
end

function Lua_TuJianTheUpgradePlane:onPageClick(go)
	self.dragList:moveToIndex(tonumber(go.name));
end

function Lua_TuJianTheUpgradePlane:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120308));
end

function Lua_TuJianTheUpgradePlane:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.TuJianTipList ~= nil then
		self.TuJianTipList:dispose();
		self.TuJianTipList:clear();
		self.TuJianTipList = nil;
	end
	if self._itemHideArr ~= nil then
		self._itemHideArr:dispose();
		self._itemHideArr:clear();
		self._itemHideArr = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TuJianTheUpgradeItem = class("Lua_TuJianTheUpgradeItem", Lua_ListCell);
function Lua_TuJianTheUpgradeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TuJianTheUpgradeItem:buildShowItem()
	self:superCall("buildShowItem");

	local cell;
	self.posx = {-330, 0, 330};
	self.cells = Array();
	for i = 1, #self.posx do
		cell = Lua_TuJianTheUpgradeSubItem.new(self.content);
		cell.content.name = "Lua_TuJianTheUpgradeSubItem"..i;
		cell:setLocation(self.posx[i], 0, 0);
		self.cells:add(cell);
	end
end

function Lua_TuJianTheUpgradeItem:setData(data)
	for i=1, self.cells:getSize() do
		self.cells[i]:setData(data.arr[data.startIndex + i]);
	end

	if self.dragParant ~= nil and self.dragParant.showRect ~= nil then
		self:checkOutBound(self.dragParant.showRect);
	end
end

function Lua_TuJianTheUpgradeItem:checkOutBound(showRect)
	local rect;
	local width = 250;
	local height = 400;
	for i = 1, self.cells:getSize() do
		rect = Lua_Rectangle.new(self.itemX + self.posx[i] - width / 2, self.itemY - height / 2, width, height);
		self.cells[i]:setShowOrHideState(showRect:containeRect(rect));
	end
end

function Lua_TuJianTheUpgradeItem:dispose()
	if self.cells ~= nil then
		self.cells:dispose();
		self.cells:clear();
		self.cells = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TuJianTheUpgradeSubItem = class("Lua_TuJianTheUpgradeSubItem", Lua_DisplayObject);
function Lua_TuJianTheUpgradeSubItem:ctor(p)
	self:superCall("ctor", p,"TuJianTheUpgradedrag_skin");
end

function Lua_TuJianTheUpgradeSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_ShowItem.new(self.content);
	self.showItem:setLocation(-16, -104, 0);
end

function Lua_TuJianTheUpgradeSubItem:setData(data)
	if data ~= nil then
		self.data = data;

		if self.monsEffect ~= nil then
			self.monsEffect:dispose();
			self.monsEffect = nil;
		end

		if self.modelTexture ~= nil then
			self.modelTexture:dispose()
			self.modelTexture = nil;
		end

		if self.playerModel ~= nil then
        	self.playerModel:dispose();
			self.playerModel = nil;
    	end

		self.illus_Class_Id = data.illusClassId; 
		self.illus_source_id = data.illus_source_id; -- 模型ID
		self.model_size = data.model_size; -- 模型比例
		self.position = data.position; -- 模型初始位置
		self.rotation =	data.rotation; -- 模型初始旋转位置

		local illus_list = DataCenter.TujianData.illus_list;
		if illus_list == nil or illus_list[data.id] == nil then -- 是否激活
			self.isActive = false;
		else
			self.isActive = illus_list[data.id];
		end
		
		self.illus_weapon_id = Lua_CommonUtil.getCommonConfig("illus_weapon_id", 1); -- 法宝类常量值

		self.player_name.text = data.illus_name;

		local property = {["health"] = 120322;["attack"] = 120323;["defence"] = 120324;["hit"] = 120325,
			["dodge"] = 120326;["crit"] = 120327;["toughness"] = 120328};
		local propertyNum = property[data.attr_type]; -- 属性转换
		self.showItem:setAttrTxt(22, 22, "[00E125]"..LanUtil.getValue(propertyNum).."[-]", "[00E125]+"..data.value.."[-]", 0); -- 属性赋值;

		if self.illus_Class_Id ~= nil  then -- 属性激活
			self.wait:setEnable(false); -- 敬请期待
			self.wjh:setEnable(false);-- 未激活
			self.wjhTxt:setEnable(false); -- 未激活
			self.yjh:setEnable(true); -- 已激活
			self.button:setEnable(false); -- 按钮隐藏
			self:showRedDot(false);
		else -- 属性未激活
			self.button:setGray(not self.isActive);
			self.button:addClickFuntion(self, self.onButtonActivateClick); -- 激活

			self.wait:setEnable(false); -- 敬请期待
			self.wjh:setEnable(true);--未激活
			self.wjhTxt:setEnable(true); -- 未激活
			self.yjh:setEnable(false); -- 已激活
			self.button:setEnable(true);
			self:showRedDot(self.isActive);
		end
		
		local illus_fashion_id = Lua_CommonUtil.getCommonConfig("illus_fashion_id", 1); -- 时装类常量值
		local illus_decorate_id = Lua_CommonUtil.getCommonConfig("illus_decorate_id", 1); -- 装饰类常量值
		self.illus_footprint_id = Lua_CommonUtil.getCommonConfig("illus_footprint_id", 1);--足迹类常量值
		if data.illus_class_id == illus_fashion_id or data.illus_class_id == illus_decorate_id then -- 时装
			self:showFashionModel();
		elseif data.illus_class_id == self.illus_footprint_id then -- 足迹
			self:showFootprintModel();
		elseif data.illus_class_id == 12 or data.illus_class_id == 13 then -- 头像和气泡
			self:showChatModel();
		else
			self:showModel();
		end
		self.spr:SetActive(true);
	else
		self.wait:setEnable(true); -- 敬请期待
		self.spr:SetActive(false);
		self:showRedDot(false);
		self.showItem:setEnable(false);

		if self.monsEffect ~= nil then
			self.monsEffect:dispose();
			self.monsEffect = nil;
		end

		if self.modelTexture ~= nil then
			self.modelTexture:dispose()
			self.modelTexture = nil;
		end

		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
	end
end

function Lua_TuJianTheUpgradeSubItem:showRedDot(val)
	if val == true then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 65, -138, 0, 0);
			self._redDot:setDepth(7);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_TuJianTheUpgradeSubItem:showFashionModel() -- 时装模型显示
	self.modelData = UsData();
    self.modelData.career = DataCenter.roleData.career;
    self.modelData.gender = 1;
    if self.data.fashion_class == 1 then
    	self.modelData.fashion_clothes_id =  self.illus_source_id -- 时装衣服
    elseif self.data.fashion_class == 2 then
    	self.modelData.fashion_weapon_id = self.illus_source_id -- 时装武器
    else
    	self.modelData.fashionHeadId = self.illus_source_id -- 时装头饰
	end
	self.modelData.nickname = "";
    self.modelData.hp = 1;
    self.modelData.kind = 2;
    self.modelData.isShowName = false;
    self.modelData.IsUI = true;

	self:updateTheUpgradeModel();
end

function Lua_TuJianTheUpgradeSubItem:updateTheUpgradeModel()
	if self.playerModel == nil then
		self.playerModel = ModelPlayer();
	end

	self.playerModel:init(self.content, Vector3(self.position[1], self.position[2], self.position[3]),
		Vector3(self.rotation[1], self.rotation[2], self.rotation[3]), self.modelData, nil, self.model_size);
	self.playerModel:SetRenderQueue(self.bg, 1, 2);
	self.playerModel:setGray(self.illus_Class_Id == nil);
end

function Lua_TuJianTheUpgradeSubItem:showFootprintModel() -- 足迹特效显示
	-- Lua_CommonUtil.removeTimer(self,self.effectLoop);
	-- Lua_CommonUtil.addTimer("footPrintEffect", 2, self, self.effectLoop);
	if self.modelTexture ~= nil then
		self.modelTexture:dispose()
		self.modelTexture = nil;
	end

	local petData = DataCenter.footprintData;
	local modelInfo = petData:getEffectInfo(self.illus_source_id);
	if self.modelTexture == nil then
		self.modelTexture = UICreate.createUIEffect(self.spr, modelInfo.floder.."/"..modelInfo.path, tostring(modelInfo.path), 0, 0);
		self.modelTexture:SetRenderQueue(self.bg, 1, 2, false);
		self.modelTexture:setGrayShader("Transparent_Gray", "Particle_Gray2");
		-- self.modelTexture:setLoop(true); -- 动画连续播放

		if self.position == nil then
			self.modelTexture:setLocation(0, -80, 250);
		else
			self.modelTexture:setLocation(self.position[1], self.position[2], self.position[3]);
		end

		if self.rotation == nil then
			self.modelTexture:setRot(15, 180, 0);
		else
			self.modelTexture:setRot(self.rotation[1], self.rotation[2], self.rotation[3]);
		end

		if self.model_size == nil then
			self.modelTexture:setSacle(100, 100, 100);
		else
			self.modelTexture:setSacle(self.model_size, self.model_size, self.model_size);
		end
	end
	self.modelTexture:setUrl(modelInfo.floder.."/"..modelInfo.path,tostring(modelInfo.path));
	self.modelTexture:setGray(self.illus_Class_Id == nil); -- 足迹特效置灰设置
end

function Lua_TuJianTheUpgradeSubItem:effectLoop()
	if self.modelTexture == nil then
		return;
	end

	local effectRoot = self.modelTexture.mainContent;
	if effectRoot ~= nil then
		effectRoot:SetActive(false);
		effectRoot:SetActive(true);
	end
end

function Lua_TuJianTheUpgradeSubItem:showChatModel()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end

	local modelInfo = DataCenter.FashionData:getItemByItemId(self.illus_source_id);
	if modelInfo ~= nil then
		if self.monsEffect == nil then
			self.monsEffect = UICreate.createUIEffect(self.spr, "/effects/scsEffects/"..modelInfo.effectName, modelInfo.effectName, 0, 0);
			self.monsEffect:SetRenderQueue(self.bg, 1, 2, false);
			self:showModelTransform();
		end
		self.monsEffect:setUrl("/effects/scsEffects/"..modelInfo.effectName, modelInfo.effectName);

		if self.illus_Class_Id ~= nil then
			self.monsEffect:setGray(false);
			if getCVersion() >= 1315 then
				self.monsEffect:setEffectShowState(true);
			end
		else
			self.monsEffect:setGray(true);
			if getCVersion() >= 1315 then
				self.monsEffect:setEffectShowState(false);
			end
		end
	end
end

function Lua_TuJianTheUpgradeSubItem:showModel() -- 模型显示
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end

	if self.monsEffect == nil then
		self.monsEffect = UICreate.createUIEffect(self.spr, nil, nil, 0, 0);
		self.monsEffect:SetRenderQueue(self.bg, 1, 2, false);
		self:showModelTransform();
	end

	local modelInfo = DataCenter.servantData:getModelInfo(self.illus_source_id);
	if modelInfo ~= nil then
		self.monsEffect:setUrl(modelInfo.floder.."/"..modelInfo.fileName, tostring(modelInfo.modelName));
	end

	if self.illus_Class_Id ~= nil then
		self.monsEffect:setGray(false);
		if getCVersion() >= 1315 then
			self.monsEffect:setEffectShowState(true);
		end
	else
		self.monsEffect:setGray(true);
		if getCVersion() >= 1315 then
			self.monsEffect:setEffectShowState(false);
		end
	end
end

function Lua_TuJianTheUpgradeSubItem:showModelTransform()
	if self.position == nil then
		self.monsEffect:setLocation(0, -80, 300);
	else
		self.monsEffect:setLocation(self.position[1], self.position[2], self.position[3]);
	end

	if self.rotation == nil then
		self.monsEffect:setRot(0, 180, 0);
	else
		self.monsEffect:setRot(self.rotation[1], self.rotation[2], self.rotation[3]);
	end

	if self.model_size == nil then
		self.monsEffect:setSacle(100, 100, 100);
	else
		self.monsEffect:setSacle(self.model_size, self.model_size, self.model_size);
	end
end

function Lua_TuJianTheUpgradeSubItem:setShowOrHideState(state)
	if self.monsEffect ~= nil then
		self.monsEffect:setEnable(state);
		if state == true then
			if self.data.illus_class_id == self.illus_weapon_id then
				self.monsEffect:setAction(1);
			end
		end
	end

	if self.playerModel ~= nil then
		self.playerModel:setActive(state);
	end

	if self.modelTexture ~= nil then
		self.modelTexture:setEnable(state);
		if state == true then
			if self.isShow ~= true then
				self.isShow = true;
				Lua_CommonUtil.addTimer("footPrintEffect", 2, self, self.effectLoop);
			end
		else
			if self.isShow == true then
				self.isShow = false;
				Lua_CommonUtil.removeTimer(self, self.effectLoop);
			end
		end
	end
end

function Lua_TuJianTheUpgradeSubItem:onButtonActivateClick()
	local calssCfg = getConfig({"tujian_calss", self.data.illus_class_id});
	local illusName = calssCfg.illus_class_name; -- 图鉴名
	if self.isActive == true then
		DataCenter.TujianData:sIllusActivateMsg(self.data.id);
		-- self.monsEffect:setGray(false);
	else
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(120321), tostring(illusName)));
	end
end

function Lua_TuJianTheUpgradeSubItem:dispose()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose()
		self.modelTexture = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.effectLoop);

	self:superCall("dispose");
end