Lua_TuJianUpgradePlane  = class("Lua_TuJianUpgradePlane", Lua_DisplayObject);
function Lua_TuJianUpgradePlane:ctor(p,illus_class_id, illus_group_id)
	self.illus_group_id = illus_group_id; -- 图鉴分组ID
	self.illus_class_id = illus_class_id; -- 图鉴类ID
	self:superCall("ctor", p, "TuJianPanel_skin", true);
end

function Lua_TuJianUpgradePlane:buildShowItem()
	self:superCall("buildShowItem");

	self.tips.text = LanUtil.getValue(120330);

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 209, 980, 550));
	self.dragList:setListCell(Lua_TuJianUpgradeItem, 550, 980, 1000);
	self.dragList:setCellScaleChange(true, 1, 1, 340, self, self.onCallBack);
	self.dragList:setLocation(131, -212, 0);

	local arr = DataCenter.TuJianUtil:getArrByClassIdAndGroupId(self.illus_class_id, self.illus_group_id);
	self.pageLen = math.ceil(arr:getSize() / 3);

	local posX;
	local icon;
	local perWidth = 40;
	self.TuJianTipList = Array();
	for i = 1, self.pageLen do
		posX = -perWidth * self.pageLen / 2 + perWidth * (i - 1) + perWidth / 2 + 130;
		icon = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_widget_2y", posX, -310, 0, 0);
		icon.name = tostring(i);
		icon:setDepth(5);
		icon:addClickFuntion(self, self.onPageClick);
		self.TuJianTipList:add(icon);
	end

	self.wenhao:addClickFuntion(self, self.onHelp); -- 问号

	self:showUpgradeInfo();
	self:addLuaEvent("SHOW_ILLUSINFO", self, self.showUpgradeInfo); -- 返回面板信息
end

function Lua_TuJianUpgradePlane:showUpgradeInfo()
	local illusArr = DataCenter.TuJianUtil:getArrByClassIdAndGroupId(self.illus_class_id,self.illus_group_id);
	local len = illusArr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not DataCenter.TujianData:canUpLvSortFun(illusArr[i], illusArr[j]) then -- 排序
				local temp = illusArr[i];
				illusArr[i] = illusArr[j];
				illusArr[j] = temp;
			end
		end
	end

	local arr = Array();
	for i = 1, self.pageLen do
		arr:add({page = i, startIndex = (i - 1) * 3, arr = illusArr});
	end
	self.dragList:setLuaArrayData(arr, true);
end

-- 点击分页
function Lua_TuJianUpgradePlane:onPageClick(go)
	self.dragList:moveToIndex(tonumber(go.name));
end

function Lua_TuJianUpgradePlane:onCallBack(index)
	for i = 1, self.TuJianTipList:getSize() do
		if i == index then
			self.TuJianTipList[i]:setAltas("common_atlas_2", "ui_common_widget_1y");
		else
			self.TuJianTipList[i]:setAltas("common_atlas_2", "ui_common_widget_2y");
		end
	end
end

function Lua_TuJianUpgradePlane:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(120307));
end

function Lua_TuJianUpgradePlane:dispose()
	if self.TuJianTipList ~= nil then
		self.TuJianTipList:dispose();
		self.TuJianTipList:clear();
		self.TuJianTipList = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TuJianUpgradeItem = class("Lua_TuJianUpgradeItem", Lua_ListCell);
function Lua_TuJianUpgradeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TuJianUpgradeItem:buildShowItem()
	self:superCall("buildShowItem");

	local cell;
	self.posx = {-330, 0, 330};
	self.cells = Array();
	for i = 1, #self.posx do
		cell = Lua_TuJianUpgradeSubItem.new(self.content);
		cell.content.name = "Lua_TuJianUpgradeSubItem"..i;
		cell:setLocation(self.posx[i], 0, 0);
		self.cells:add(cell);
	end
end

function Lua_TuJianUpgradeItem:setData(data)
	for i = 1, self.cells:getSize() do
		self.cells[i]:setData(data.arr[data.startIndex + i]);
	end
end

function Lua_TuJianUpgradeItem:checkOutBound(showRect)
	local rect;
	local width;
	local height;
	for i = 1, self.cells:getSize() do
		width = self.cells[i].monsEffect ~= nil and self.cells[i].monsEffect.width or 312;
		height = self.cells[i].monsEffect ~= nil and self.cells[i].monsEffect.height or 542;
		rect = Lua_Rectangle.new(self.itemX + self.posx[i] - width / 2, self.itemY - height / 2, width, height);
		self.cells[i]:setShowOrHideState(showRect:containeRect(rect));
	end
end

function Lua_TuJianUpgradeItem:dispose()
	if self.cells ~= nil then
		self.cells:dispose();
		self.cells:clear();
		self.cells = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TuJianUpgradeSubItem = class("Lua_TuJianUpgradeSubItem", Lua_DisplayObject);
function Lua_TuJianUpgradeSubItem:ctor(p)
	self:superCall("ctor", p, "TuJianUpgradeRight_skin");	
end

function Lua_TuJianUpgradeSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_ShowItem.new(self.content);
	self.showItem:setLocation(-116.5, -124, 0);

	self.name:addClickFuntion(self, self.onToComing); -- 寻路
end

function Lua_TuJianUpgradeSubItem:setData(data)
	if data ~= nil then
		self._data = data;

		self.monsterPox = DataCenter.mapWindowUtil:getSceneMonsterPox(data.sence_id, data.monster_id); -- 怪物坐标 -用于寻路

		self.curCfg = getConfig({"monster", data.monster_id}); -- 怪物ID 用于寻路 和查找怪物名字
		self.name.text = self.curCfg.name; -- 怪物名字显示

		local itemId;
		if data.illus_class_id == 1 then
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_monster", 1); -- 万能野外怪物图鉴道具
		else
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_boss", 1); -- 万能boss图鉴道具
		end
		local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		self.getItemNum = packData:getItemNum(data.upgrade_goods_id) -- 身上物品数量
		self.getAllItemNum = packData:getItemNum(itemId) -- 身上的万能道具
		self.allItemNum = self.getItemNum + self.getAllItemNum; -- 图鉴 + 万能图鉴

		local property = {["health"] = 120313, ["attack"] = 120314, ["defence"] = 120315,
			["hit"] = 120316, ["dodge"] = 120317, ["crit"] = 120318, ["toughness"] = 120319};
		local illus_Max_level = data.illus_level; -- 等级上限
		local propertyNum = property[data.attr_type]; -- 属性转换
		local property_Value_Num = data.value_list[data.illusLevel]; -- 当前图鉴的属性值
		local illus_Max_property = data.goods_amount_list[data.illusLevel]; -- 属性上限
		self.illus_Class_Id = data.illusClassId; -- 服务端下发的信息，这里用于是否激活判断;
		if self.illus_Class_Id ~= nil then -- 属性已激活
			self.bg:setAltas("tujian_atlas", "ui_atlas_bg_01");

			local showColor = self.allItemNum >= data.needTujianCount and "[00FFB4]" or "[FF1616]";
			self.progressBar:setText(LanUtil.formateStr(showColor.."{1}[-]/{2}", tostring(self.allItemNum), tostring(data.needTujianCount)));
			self.progressBar:setMaxValue(data.needTujianCount);
			self.progressBar:setValue(self.allItemNum);

			self.jindutext.text = LanUtil.formateStr(LanUtil.getValue(120305), tostring(data.illusLevel)); -- 进度

			self:showRedDot(self.allItemNum >= data.needTujianCount);
			if data.illusLevel < illus_Max_level then
				local property_Next_Num = data.value_list[data.illusLevel + 1]; -- 下等级属性值
				local property_Show_Next = property_Next_Num - property_Value_Num;
				self.showItem:setAttrTxt(22, 22, LanUtil.getValue(propertyNum), LanUtil.formateStr(LanUtil.getValue(120331), tostring(property_Value_Num), tostring(property_Show_Next)), -7);
			else
				self.showItem:setAttrTxt(22, 22, LanUtil.getValue(propertyNum), property_Value_Num, -7);

				self.progressBar:setText(illus_Max_property.."/" ..illus_Max_property.."[FF1616](MAX)[-]");
				self.progressBar:setMaxValue(illus_Max_property);
		   		self.progressBar:setValue(illus_Max_property);

				self.max:setEnable(true); -- 满级
				self:showRedDot(false);
			end
			self.button.label = LanUtil.getValue(120310);
			self.button:setEnable(data.illusLevel < illus_Max_level);
			self.button:setGray(self.allItemNum < data.needTujianCount);
			self.button:addClickFuntion(self, self.onTipsClick);--升级
			self.button:removeClickFuntion(self, self.onButtonActivateClick);

			self.wjh:setEnable(false); -- 未激活
			self.wjhTxt:setEnable(false); -- 未激活
			self.max:setEnable(false); -- 满级
		else -- 属性未激活
			self.bg:setAltas("tujian_atlas", "ui_atlas_bg_01"); -- 背景置灰

			self.showItem:setAttrTxt(22, 22, LanUtil.getValue(propertyNum), LanUtil.formateStr(LanUtil.getValue(120331), tostring(0), tostring(data.value_list[1])), -7);

			local showNum = self.getItemNum >= data.goods_amount_list[1] and 1 or 0;
			local showColor = self.getItemNum >= data.goods_amount_list[1] and "[00FFB4]" or "[FF1616]";
			self.progressBar:setText(LanUtil.formateStr(showColor.."{1}[-]/{2}", tostring(showNum), tostring(data.goods_amount_list[1])));
			self.progressBar:setMaxValue(data.goods_amount_list[1]);
			self.progressBar:setValue(showNum);

			self.button.label = LanUtil.getValue(120309);
			self.button:setGray(self.getItemNum < data.goods_amount_list[1]);
			self.button:addClickFuntion(self, self.onButtonActivateClick); -- 激活
			self.button:removeClickFuntion(self, self.onTipsClick); -- 升级

			self.jindutext.text = LanUtil.formateStr(LanUtil.getValue(120305), tostring(0)); -- 进度
			
			self.wjh:setEnable(true); -- 未激活
			self.wjhTxt:setEnable(true); -- 未激活
			self.button:setEnable(true);
			self.max:setEnable(false); -- 满级
			self:showRedDot(self.getItemNum >= data.goods_amount_list[1]); -- 红点显示
		end
		self:showModel();

		self.wait:setEnable(false); -- 敬请期待
		self.spr:SetActive(true);
	else
		self.bg:setAltas("tujian_atlas", "ui_atlas_bg_01"); -- 背景置灰
		if self.monsEffect ~= nil then
			self.monsEffect:dispose();
			self.monsEffect = nil;
		end

		self.wait:setEnable(true); -- 敬请期待
		self.spr:SetActive(false);
		self:showRedDot(false);
	end
end

function Lua_TuJianUpgradeSubItem:showRedDot(val)
	if val == true then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 70, -210, 0, 0);
			self._redDot:setDepth(7);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_TuJianUpgradeSubItem:showModel()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end

	local modelStr = "/model/"..self.curCfg.jid;
	if self.monsEffect == nil then
		self.monsEffect = UICreate.createUIEffect(self.spr, modelStr, self.curCfg.jid, 0, 0);
		self.monsEffect:SetRenderQueue(self.bg, 1, 2);
		self:showModelTransform()
	end
	self.monsEffect:setUrl(modelStr, self.curCfg.jid)
	self.monsEffect:setGray(self.illus_Class_Id == nil);
end

function Lua_TuJianUpgradeSubItem:showModelTransform()
	if self._data.position == nil then
		self.monsEffect:setLocation(0, -30, 200);
	else
		self.monsEffect:setLocation(self._data.position[1], self._data.position[2], self._data.position[3]);
	end

	if self._data.rotation == nil then
		self.monsEffect:setRot(0, -180, 0);
	else
		self.monsEffect:setRot(self._data.rotation[1], self._data.rotation[2], self._data.rotation[3]);
	end

	if self._data.model_size == nil then
		self.monsEffect:setSacle(1, 1, 1);
	else
		self.monsEffect:setSacle(self._data.model_size, self._data.model_size, self._data.model_size);
	end
end

function Lua_TuJianUpgradeSubItem:setShowOrHideState(val)
	if self.monsEffect ~= nil then
		self.monsEffect:setEnable(val);
	end
end

function Lua_TuJianUpgradeSubItem:onToComing()
	-- WorldMapUtil.canGotoTargetScene(20101); -- 判断是否可以寻路到目标场景
	-- DataCenter.roleData:isScenceOpen(20101); -- 判断场景是否开启
	-- Scene3DControl.getInstance().CanWalkThePath -- 判断目标点是否可寻路过去
	if self._data.illus_class_id == 1 then
		if DataCenter.roleData:isScenceOpen(self._data.sence_id) == true then
			DataCenter.hook:stop(true);
			if DataCenter.roleData.sceneId ~= self._data.sence_id then
				local pos = getConfig({"scene", self._data.sence_id, "fixed_pos"});
				Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(self._data.sence_id, pos[1], pos[2], pos[3], 0);
				self:addCSharpEvent("INIT_SCENE_CONFIG_OBJECT", self, self.onSceneLoaded);
			else
				-- print("当前场景寻路")
				WorldMapUtil.moveTo(self._data.sence_id, self.monsterPox.posX, self.monsterPox.posY,
					self.monsterPox.posZ, self._data.monster_id, 3, nil, 0);
				Lua_WindowUtil.openWin("Lua_TuJianWindow", WinParam.ACTION_CLOSE);
			end
		else
			OperateAlert.show(LanUtil.getValue(120303));
		end
	else
		DataCenter.bossData.checkBossId = self._data.monster_id;

		local illus_group_name = getConfig({"illus_upgrade_group", self._data.illus_group_id, "illus_group_name"});
		if self._data.illus_group_id == 205 then
			Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, 5); -- 神兽岛特殊处理
		else
			Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, Lua_BossData.BOSS_NAME_2_INDEX[illus_group_name]);
		end
		Lua_WindowUtil.openWin("Lua_TuJianWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_TuJianUpgradeSubItem:onSceneLoaded()
	-- DataCenter.hook:stop(true);
	WorldMapUtil.moveTo(self._data.sence_id, self.monsterPox.posX, self.monsterPox.posY, self.monsterPox.posZ, self._data.monster_id, 3, nil, 0);
	Lua_WindowUtil.openWin("Lua_TuJianWindow", WinParam.ACTION_CLOSE);
end

function Lua_TuJianUpgradeSubItem:onButtonActivateClick()
	if self.getItemNum < self._data.goods_amount_list[1] then
		OperateAlert.show(LanUtil.getValue(120311))
	else
		-- print("激活图鉴ID"..self._data.id);
		DataCenter.TujianData:sIllusUppgradeMsg(self._data.id);
	end
end

function Lua_TuJianUpgradeSubItem:onTipsClick()
	if self.getAllItemNum > 0 then
		if self.getItemNum >= self._data.needTujianCount then
			DataCenter.TujianData:sIllusUppgradeMsg(self._data.id);
		else
			if self.allItemNum >= self._data.needTujianCount then
				if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.RELIVE) == true then
					self:onButtonUpgradeClick();
				else
					Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, neverTip = Lua_NeverTipData.RELIVE,
						des = LanUtil.getValue(120320), type = 1, subFun = self.onButtonUpgradeClick});
				end
			else
				OperateAlert.show(LanUtil.getValue(120311))
			end
		end
	else
		if self.getItemNum >= self._data.needTujianCount then
			DataCenter.TujianData:sIllusUppgradeMsg(self._data.id);
		else
			OperateAlert.show(LanUtil.getValue(120311));
		end
	end
end

function Lua_TuJianUpgradeSubItem:onButtonUpgradeClick()
	DataCenter.TujianData:sIllusUppgradeMsg(self._data.id);
end

function Lua_TuJianUpgradeSubItem:dispose()
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	self:superCall("dispose");
end