checkRequire("Lua_TuJianUpgradePlane");
checkRequire("Lua_TuJianTheUpgradePlane");
Lua_TuJianWindow = class("Lua_TuJianWindow", Lua_FullSizeWindow);
function Lua_TuJianWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TuJianWindow";
	self.skinName = "TuJianWindow_skin";
end

function Lua_TuJianWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self:setShowTitle("titleName_altas_1", "tujian");

	local arr = DataCenter.TuJianUtil:getIllusCalssList();
	self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, -230, 230, 510), nil, nil, Vector2(0, -15), Vector2(0, 6));
	self.btnList:setData(arr, self, self.onSubClick);
	self.btnList:setLocation(-497, 235, 0);
	self.btnList:setMainSlected(1, 1);

	self.Button:addClickFuntion(self, self.onButtonClick);

	self:addLuaEvent("SHOW_ILLUSINFO", self, self.updateShowRodDataList);
	DataCenter.TujianData:sIllusMsg();
end

-- 图鉴属性
function Lua_TuJianWindow:onSubClick(data)
	self.selectedData = data;
	if self.tuJianPanel ~= nil then
		self.tuJianPanel:dispose();
		self.tuJianPanel = nil;	
	end

	if data.illus_group_id ~= nil then
		self.tuJianPanel = Lua_TuJianUpgradePlane.new(self.content, data.illus_class_id, data.illus_group_id);
	else
		self.tuJianPanel = Lua_TuJianTheUpgradePlane.new(self.content, data.illus_class_id, DataCenter.roleData.career);
	end
	self:updateShowRod();
end

function Lua_TuJianWindow:updateShowRodDataList()
	local arr = DataCenter.TuJianUtil:tuJianCalssInfo();
	local isClassidList;
	local rodList = {};
	for k,v in pairs(arr) do
		isClassidList = DataCenter.TuJianUtil:getIllusIsClassId(k);
		for i,j in pairs(isClassidList) do
			rodList[k] = j;
		end
	end
	self.btnList:setRedDot(1, rodList);
	self:updateShowRod();
end

function Lua_TuJianWindow:updateShowRod()
	if self.selectedData == nil then
		return;
	end

	local arr = DataCenter.TuJianUtil:tuJianCalssInfo();
	self.rodList = {}
	for k,v in pairs(arr) do
		if v.illus_group_list ~= nil then
			local isGroupidList = DataCenter.TuJianUtil:getIllusIsGroupId(k);
			self.rodList[k] = {};
			for i, j in pairs(v.illus_group_list) do
				self.rodList[k][i] = isGroupidList[j];
			end
		end
	end
	self.btnList:setRedDot(2, self.rodList[self.selectedData.mainIndex]);
end

function Lua_TuJianWindow:onButtonClick()
	Lua_WindowUtil.openWin("Lua_TuJianPropertyWindow", WinParam.ACTION_AUTO, DataCenter.TujianData.prop_list);
end

function Lua_TuJianWindow:dispose()
	if self.tuJianPanel ~= nil then
		self.tuJianPanel:dispose();
		self.tuJianPanel = nil;	
	end
	self:superCall("dispose");
end